﻿#Auteur : Alexandra Réalini#
#Créer un programme permettant de déterminer le réactif limitant de la réaction suivante#
# NH2–N(CH3)2 (ℓ) + 2 N2O4 (ℓ) donne 2 CO2 (g) + 3 N2 (g) + 4 H2O (g)#
#On fera calculer par le programme dans un premier temps les masses m1 et m2 respectivement de UDMH et de NTO dans les réservoirs#
#On tracera enfin les courbes représentant les variations des quantités de matière des réactifs et des produits en foinction de l'avancement x#
# modifier le programme au niveau des ? rouge #

#Variables liées à UDMH #
import matplotlib.pyplot as plt
m1= input("quel est la masse en gramme d'UDMH?")  # le programme demande à l'utilisateur d'entrer la masse de UDMH#
m1 = float(m1)  # m1 devient un décimal #
print("m1=", m1,"g") # m1 = la valeur entrée par l'utilisateur en gramme#
M1= ? # Entrer la masse molaire  de UDMH en gramme par mole#

#Variables liées à NTO #
m2= input("quel est la masse en gramme de NTO?")  # le programme demande à l'utilisateur d'entrer la masse de NTO#
m2 = float(m2)  # m2 devient un décimal #
print("m2=", m2,"g") # m2 = la valeur entrée par l'utilisateur en gramme#
M2= ? # Entrer la masse molaire de NTO en gramme par mole#

#création de la phrase réponse qui sera compléter par la fonction format#
reponse="le réactif limitant est {} et xmax = {} mol"

#Création des variables liées au premier réactif#
reactif1= "UDMH"
n1 = ?  # Entrer l'expression de la quantité de matière initiale en fonction des données

#Création des variables liées au second réactif#
reactif2= "NTO"
n2 = ? # Entrer l"expression de la quantité de matière initiale en fonction des données

#Création  avancement maximal et des conditions sur xmax#
xmax1=?   #  Entrer l'expression de xmax1, si UDMH est limitant.
xmax2= ? # Entrer l'expression de xmax2 si NTO est limitant.
if ?:   # Entrer  la condition pour que UDMH soit limitant
    print(reponse.format(reactif1,"%e"%?)) # Compléter par xma1 ou xma2. Ecrit que le réactif limitant est UDMH  et donne la valeur de xmax en notation scientifique dans la phrase réponse#
    xmax= ?  #Indiquer dans ces conditions l'expression de xmax#
elif ?:  # Entrer  la condition pour que NTO soit limitant
    print(reponse.format(reactif2,"%e"%?)) #Compléter par xmax1 ou xmax2. Ecrit que le réactif limitant est NTO et donne la valeur de xmax en notation scientifique dans la phrase réponse#
    xmax= ?   #Indiquer dans ces conditions l'expression de xmax#
elif ?:   # Entrer  la dernière possibilité
    print ("les réactifs sont dans les proportions stoechiométriques et ils sont totalement consommés")
    print ("xmax=",?)  #Compléter par xmax1 ou xmax2.
    xmax=?  #Indiquer dans ces conditions l'expression de xmax#

# Tracé du graphique quantités de matière des réactifs et des produits en fonction de l'avancement x

def n1x(x):                   # quantité de UDMH en fonction de l'avancement x
    return ? # Entrer l'expression de  la quantité de UDMH en fonction de l'avancement x

def n2x(x):      # quantité de NTO en fonction de l'avancement x
    return ?  #  Entrer l'expression de la quantité de NTO en fonction de l'avancement x

def n3x(x):      # quantité de CO2 en fonction de l'avancement x
    return ?    # Entrer l'expression de la quantité de CO2 en fonction de l'avancement x

def n4x(x):               # quantité de N2 en fonction de l'avancement x
    return ?    # Entrer l'expression de laquantité de N2 en fonction de l'avancement x

def n5x(x):    # quantité de H20 en fonction de l'avancement x
    return ?  # Entrer l'expressio de la quantité de H20 en fonction de l'avancement x


plt.grid(True)  # trace des grilles sur le graphe

plt.plot([n1x(x) for x in range (round(xmax))]) # trace les différentes courbes pour x variant jusqu'à l'entier le plus proche de xmax.
plt.plot([n2x(x) for x in range (round(xmax))])
plt.plot([n3x(x) for x in range (round(xmax))])
plt.plot([n4x(x) for x in range (round(xmax))])
plt.plot([n5x(x) for x in range (round(xmax))])

plt.title("quantités de matière en mol des réactifs et des produits en fonction de l'avancement x")  # titre du graphique
plt.xlabel("avancement x en mol")  # nom de l'axe des abscisses
plt.legend(['quantité de UDMH','quantité de NTO','quantité de CO2','quantité de N2 ','quantité de H20'])  # noms des différentes courbes

plt.show()  # affiche les courbes







